require "import"
import "android.net.Uri"
import "android.text.Html"
import "com.androlua.Http"
import "java.util.Locale"
import "android.os.Handler"
import "android.os.Looper"
import "android.os.Vibrator"

local cjson = require("cjson")  -- استيراد مكتبة cjson

function dictFr()
  if service.getEditText() then
    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local vibrator = activity.getSystemService("vibrator")

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "fr-FR")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then
            if text:lower() == "annuler la dictée" then
              this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
              service.execute("清空")
              return
            elseif text:lower() == "envoyer" then
              send()
              return
            elseif text:lower() == "stop" then
              recognizer.stopListening()
              recognizer.destroy()
              recognizer = nil
              this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")
              return
            elseif text:lower() == "annuler" then
              if service.getEditText() then
                this.postSpeak(200, "أَعدِ المحاولة. ")
                local node = service.getEditText()
                local text = service.getText(node)
                local lastLineBreak = text:match(".*()\n")
                if lastLineBreak then
                  text = text:sub(1, lastLineBreak - 0)
                else
                  text = ""
                end
                service.setText(text)
                task(1500, function()
                  startVoiceRecognition(activity)
                end)
              else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return
            elseif text:lower() == "nouveau" then
              service.execute("清空")
              task(1600, function()
                startVoiceRecognition(activity)
              end)
              return
            elseif text:lower() == "lire le texte" then
              if service.getEditText() then
                local node = service.getEditText()
                local text = service.getText(node)
                this.postSpeak(200, text)
                local function checkSpeakingStatus()
                  if not service.isSpeaking() then
                    startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                  else
                    handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                  end
                end
                handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
                return
              else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
            elseif text:lower() == "général" then
              this.postSpeak(200, "الأوامرُ الرئيسية")
              task(1500, function()
                general()
              end)
              return
            elseif text:lower() == "pause" then
              this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")
              handler.postDelayed(function()
                startVoiceRecognition(activity)
              end, 15000)
              return
            end

            service.paste(text .. " \n")
            this.postSpeak(200, text)

            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity)
              else
                handler.postDelayed(checkSpeakingStatus, 1000)
              end
            end

            handler.postDelayed(checkSpeakingStatus, 1500)
          else
            startVoiceRecognition(activity)
          end
        end,
        onError = function(error)
          this.postSpeak(200,"لم يتم التقاط أي نص.")
        end
      })

      recognizer.setRecognitionListener(recognitionListener)
      recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
  else
    this.postSpeak(200, "لا يوجد مربع تحرير. ")
  end
end

dictFr()